;LZ4GV 2004-09
; .
;   .
;PIC16F88
;LCD  PC8578
Firmware	EQU	.11

	list		p=16F88		; list directive to define processor
	#include	<p16F88.inc>	; processor specific variable definitions

;Program Configuration Register 1
	__CONFIG    _CONFIG1, _INTRC_IO & _CP_OFF & _CPD_OFF & _BODEN_ON & _CCP1_RB3 & _MCLR_OFF & _DEBUG_OFF & _WRT_PROTECT_OFF & _LVP_OFF & _PWRTE_ON & _WDT_OFF

;Program Configuration Register 2
	__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF

OSCTUNE_MNL	EQU	.0	;Central frequency	min .32 - .63  0  .1 - .31 max

			;PORTA
#define	RA0		PORTA,0		;Analog IN : Current
#define	RA1		PORTA,1		;Analog IN : Voltage
#define	RA2		PORTA,2		;Analog OUT: CVref <=>   
#define	RA3		PORTA,3		; IN : Vrev = 4,092V
#define	DISCHARGE	PORTA,4		;Digital OUT:  .
#define	CoolWarm	PORTA,5		;Digital IN:  
#define	B_DN		PORTA,6		;Digital IN:  'Up'
#define	B_UP		PORTA,7		;Digital IN:  'Down'

#define	SCL_PCF8578	PORTB,0		;Out: Clock LCD
#define	SCL_PCF8578_IO	TRISB,0		;-//-
#define	SDA_PCF8578	PORTB,1		;In/Out: Data LCD
#define	SDA_PCF8578_IO	TRISB,1		;-//-
#define	RB2		PORTB,2		;n.c.
#define	RB3		PORTB,3		;Out: PWM   
#define	B_Current	PORTB,4		; In:
#define	B_LockMode	PORTB,5		; In:
#define	RB6		PORTB,6		;
#define	CoolFan		PORTB,7		;Out: Fan


#define	BitRW_I2C	0x20,0
#define	EndByte_I2C	0x20,1
#define	SupplyOFF	0x20,2

COUNT_N		EQU	0x21

COUNT_HISPEED	 EQU	0x24

LEVEL_MEM	EQU	0x25

COUNT_SCR	EQU	0x26

TIME_DISL	EQU	0x27
TIME_DISM	EQU	0x28

CURRENT_L	EQU	0x29
CURRENT_H	EQU	0x2A

CURRENT_COR1	EQU	0x2B		;
CURRENT_COR2H	EQU	0x2C		;
CURRENT_COR2L	EQU	0x2D		;

COUNT3		EQU	0x2E
COUNT4		EQU	0x2F

;**********************************************************************
HEX1		EQU	0x30	;   HEX->DEC.
HEX2		EQU	0x31	;-//-
HEX3		EQU	0x32	;
HEX4		EQU	0x33	;FFFFFFFFh=.4294967295
DEC1		EQU	0x34	;
DEC2		EQU	0x35	;
DEC3		EQU	0x36	;
DEC4		EQU	0x37	;
DEC5		EQU	0x38	;
DEC6		EQU	0x39	;
DEC7		EQU	0x3A	;
DEC8		EQU	0x3B	;
DEC9		EQU	0x3C	;
DEC10		EQU	0x3D	;
;COUNT		EQU	0x	;  HEX->DEC.
;COUNT1		EQU	0x	;-//-
;**********************************************************************

;**********************************************************************
;HEX4		EQU	0x
;HEX3		EQU	0x
;HEX2		EQU	0x
;HEX1		EQU	0x
HEX4MEM		EQU	0x40
HEX3MEM		EQU	0x41
HEX2MEM		EQU	0x42
HEX1MEM		EQU	0x43
;COUNT		EQU	0x
;**********************************************************************

;**********************************************************************
COUNT		EQU	0x51	;    .
COUNT1		EQU	0x52	;-//-
COUNT2		EQU	0x53	;-//-
FSRMEM1		EQU	0x54	;-//-
LETTER_L	EQU	0x55	;-//-
LETTER_H	EQU	0x56	;-//-
FIGURE		EQU	0x57	;-//-
SPL_A		EQU	0x58	;-//-
SPL_B		EQU	0x59	;-//-
SPL_C		EQU	0x5A	;-//-

				;     .
#define	SPOWER		0x5B,0	; 'Power'
#define	CIRCLE		0x5B,1	;
#define	TRIANG		0x5B,2	;
#define	SQUARE		0x5B,3	;
#define	ARROW		0x5B,4	;
#define	SPEAKER		0x5B,5	;
#define	KEY		0x5B,6	;

DIGIT10		EQU	0x5C	;Start address RAM.
DIGIT9		EQU	0x5D
DIGIT8		EQU	0x5E
DIGIT7		EQU	0x5F
DIGIT6		EQU	0x60
DIGIT5		EQU	0x61
DIGIT4		EQU	0x62
DIGIT3		EQU	0x63
DIGIT2		EQU	0x64
DIGIT1		EQU	0x65	;End address RAM.

TYPE10		EQU	0x66	;Start address RAM.
TYPE9		EQU	0x67
TYPE8		EQU	0x68
TYPE7		EQU	0x69
TYPE6		EQU	0x6A
TYPE5		EQU	0x6B
TYPE4		EQU	0x6C
TYPE3		EQU	0x6D
TYPE2		EQU	0x6E
TYPE1		EQU	0x6F	;End address RAM.
;**********************************************************************

FSRMEM		EQU	0x70	;
PCLMEM		EQU	0x71	;
ACQT		EQU	0x72	;
TMR0MEM		EQU	0x73	;
TMR1LMEM	EQU	0x74	;
TMR1HMEM	EQU	0x75	;

				;0x70 to 0x7F	Bank 0,1,2,3
INTCONMEM	EQU	0x7A	;Bank 0,1,2,3
REEADR		EQU	0x7B	;Bank 0,1
REEDATA		EQU	0x7C	;Bank 0,1
W_TEMP		EQU	0x7D	;Bank 0,1
STATUS_TEMP	EQU	0x7E	;Bank 0,1
PCLATH_TEMP	EQU	0x7F	;Bank 0,1

				;0xA0 to 0xEF	Bank 1
OPTIONMEM	EQU	0xA0	;
				;0x110 to 0x16F	Bank 2
				;0x190 to 0x1EF	Bank 3

#define	WPAGE		PCLATH,3	;0- Work. Page0		1- Work. Page1
#define	FSRBANK		STATUS,IRP	;0- Bank1,2		1- Bank2,3	    FSR.

;**********************************************************************
MinVoltage	EQU	.5	;  0,5V
MaxVoltage	EQU	.250	;  25V
;**********************************************************************

#define	Model		0x2100
#define	Mode		0x2101
#define	CurrentLimit	0x2102
#define	VoltageLevel	0x2103

	ORG	Model		;
	DE	D'1'		;D'0' -> 1A 	D'1' -> 3A	D'2' -> 10A	D'3' ->
	ORG	Mode
	DE	D'0'		;   0 -> 	1-> ....
	ORG	CurrentLimit
	DE	D'1'
	ORG	VoltageLevel
	DE	D'100'		;10V


	ORG	0x0000
	GOTO	START
;**********************************************************************
	ORG	0x0004		;Interrupt vector location
	MOVWF   W_TEMP		;      (W register).
	MOVF	STATUS,W	;Move STATUS register into W register
	MOVWF	STATUS_TEMP	;Save off contents of STATUS register
	MOVF	PCLATH,W	;Move PCLATH register into W register
	MOVWF	PCLATH_TEMP	;Save off contents of PCLATH register
	bcf	STATUS,RP1	;Bank0
	bcf	STATUS,RP0	;
	bcf	PCLATH,3	;0- Work. Page0 (Bank0)
	;;;

	;;;
	GOTO	END_INTERRUPT	;-->

END_INTERRUPT			;    .
	MOVF    PCLATH_TEMP,W	;Retrieve copy of PCLATH register
	MOVWF	PCLATH		;Restore pre-isr PCLATH register contents
	MOVF    STATUS_TEMP,W	;Retrieve copy of STATUS register
	MOVWF	STATUS		;Restore pre-isr STATUS register contents
	SWAPF   W_TEMP,F	;Restore pre-isr W register contents
	SWAPF   W_TEMP,W	;-//-
	RETFIE			;Return From Interrupt / Enable Globa
;**********************************************************************

;**********************************************************************
BEGIN
	CALL	INI_LCD		;Initialization LCD Display PCF8578

	movlw	.0		;.0
	MOVWF	PCLATH		;    ORG 0x000 to 0x0FF !!!

	movlw	Model		;    .
	movwf	REEADR		;
	CALL	READE		;In:F(REEADR)	Out:F(REEDATA),W
	andlw	B'00000011'
	addwf	PCL,F
	GOTO	MODEL_1A	;
	GOTO	MODEL_3A	;
	GOTO	MODEL_10A	;
	GOTO	MODEL_RESERVE	;

MODEL_1A
MODEL_RESERVE

MODEL_3A			;
	movlw	.30		;10bit step 3mA for  3,069A Power Supply
	movwf	CURRENT_COR1	;    

	movlw	0x00		;150mA 15     
	movwf	CURRENT_COR2H	;0,75A/V
	movlw	0x96		;
	movwf	CURRENT_COR2L	;

	GOTO	MAIN_START

MODEL_10A			;
	movlw	.100		;10bit step 10mA for 10,23A Power Supply
	movwf	CURRENT_COR1	;    

	movlw	0x01		;500mA 15     
	movwf	CURRENT_COR2H	;2,5A/V
	movlw	0xF4		;
	movwf	CURRENT_COR2L	;

	GOTO	MAIN_START
;**********************************************************************

;**********************************************************************
MAIN				;   .
	movlw	Mode
	movwf	REEADR
	CALL	READE		;In:F(REEADR)	Out:F(REEDATA),W
	incf	REEDATA,W
	andlw	B'00000011'
	movwf	REEDATA
	CALL	WRITE

MAIN_START
	bcf	DISCHARGE	;

				;Pulse Width Modulation
	clrf	CCPR1L		;Bit 9 - 2	F(CCPR1L)
	bcf	CCP1CON,CCP1X	;Bit 1
	bcf	CCP1CON,CCP1Y	;Bit 0

	bcf	CoolFan		;

;*******       
	clrf	HEX4
	clrf	HEX3
	clrf	HEX2
	movlw	Firmware
	movwf	HEX1
	BCF	FSRBANK		;0- Bank1,2	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
				;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
	movlw	A'V'
	movwf	TYPE10
	movlw	A'E'
	movwf	TYPE9
	movlw	A'R'
	movwf	TYPE8
	movlw	A'.'
	movwf	TYPE7
	movf	DEC2,W
	movwf	TYPE6
	movf	DEC1,W
	movwf	TYPE5
	movlw	A' '
	movwf	TYPE4

	movf	CURRENT_COR1,W
	movwf	HEX1
	BCF	FSRBANK		;0- Bank1,2	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
				;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
	movf	DEC3,W
	movwf	TYPE3
	movf	DEC2,W
	movwf	TYPE2
	movlw	A'A'
	movwf	TYPE1

	CALL	LOAD_LCD	;

	movlw	.7			;2PC * 260 * 258 * W = 1S
	movwf	COUNT3			;
	clrf	COUNT2			;
	clrf	COUNT1			;
Timer_1a				;
	decfsz	COUNT1,F		;
	GOTO	Timer_1a		;--^
	decfsz	COUNT2,F		;
	GOTO	Timer_1a		;--^
	decfsz	COUNT3,F		;
	GOTO	Timer_1a		;--^
;*******

	clrf	COUNT_N		;     .
B_FILTER_1			;(       )
	btfsc	B_UP
	clrf	COUNT_N
	btfsc	B_DN
	clrf	COUNT_N
	btfsc	B_Current
	clrf	COUNT_N
	btfsc	B_LockMode
	clrf	COUNT_N
	decfsz	COUNT_N,F
	GOTO	B_FILTER_1

	bcf	SupplyOFF

	movlw	.0		;.0
	movwf	PCLATH		;    ORG 0x000 to 0x0FF !!!

	movlw	Mode
	movwf	REEADR
	CALL	READE		;In:F(REEADR)	Out:F(REEDATA),W
	andlw	B'00000011'
	addwf	PCL,F
	GOTO	POWER_SUPPLY	;
	GOTO	POWER_SUPPLY	;BATT_TEST	;  EEPROM
	GOTO	POWER_SUPPLY	;CHARGE_PB	;
	GOTO	POWER_SUPPLY	;CHARGE_PB	;
;**********************************************************************

;**********************************************************************
POWER_SUPPLY
	movlw	CurrentLimit	; -.
	movwf	REEADR		;
	CALL	READE		;In:F(REEADR)	Out:F(REEDATA),W
	movf	REEDATA,W	;
	CALL	SET_CVREF	;Enable Comparator Voltage Reference Module & Reset - RA2

	movlw	VoltageLevel	;    . EEPROM address
	movwf	REEADR		;
	CALL	READE		;
	movf	REEDATA,W	;
	movwf	CCPR1L		;

	bsf	SPOWER		; 'Power'

				;Pulse Width Modulation
				;Bit 9 - 2	F(CCPR1L)
	bcf	CCP1CON,CCP1X	;Bit 1
	bcf	CCP1CON,CCP1Y	;Bit 0

	movlw	.16		;
	movwf	COUNT_SCR	;

SUPPLY
	btfss	B_LockMode	;   .
	GOTO	$+4		;
	btfss	B_Current	;
	GOTO	$+2		;
	GOTO	MAIN		;-->
	NOP			;

	btfsc	CoolWarm	;     .
	bsf	CoolFan		; 
	btfss	CoolWarm	;
	bcf	CoolFan		;

	btfsc	B_LockMode	;
	CALL	SUPPLY_ONOFF	;

	btfss	B_Current		; -.
	GOTO	SUPPLY2			;
	BTFSC	B_UP			;
	CALL	LimitCurrentStart	;
	BTFSC	B_DN			;
	CALL	LimitCurrentStart	;
SUPPLY2					;

	btfsc	SupplyOFF		;     .
	GOTO	$+5			;
	btfsc	B_UP			;     .
	CALL	SetVoltage		;
	btfsc	B_DN			;
	CALL	SetVoltage		;

	MOVLW	A'V'
	MOVWF	TYPE10
	MOVLW	A'O'
	MOVWF	TYPE9
	MOVLW	A'L'
	MOVWF	TYPE8
	MOVLW	A'T'
	MOVWF	TYPE7
	MOVLW	A' '
	MOVWF	TYPE6
	MOVLW	A' '
	MOVWF	TYPE5
	MOVLW	A'C'
	MOVWF	TYPE4
	MOVLW	A'U'
	MOVWF	TYPE3
	MOVLW	A'R'
	MOVWF	TYPE2
	MOVLW	A'R'
	MOVWF	TYPE1

	CALL	SHOW_VOLTAGE		;     (DIGIT10 - DIGIT6).

	movlw	A' '
	movwf	DIGIT5

	CALL	SHOW_CURRENT_FILTER	;       16 .
					;(DIGIT4-DIGIT1)

	bcf	ARROW			;
	CALL	LOAD_LCD		;

	MOVLW	.10		;In: W	(2,048xW)mS
	MOVWF	TMR1HMEM	;
	CLRF	TMR1L		;Max period 8uS * 65536 = 524,288mS
	COMF	TMR1HMEM,W	;
	MOVWF	TMR1H		;
	BCF	PIR1,TMR1IF	;
TIMER1				;
	BTFSS	PIR1,TMR1IF	;
	GOTO	TIMER1		;Overflow TMR1 -> 
	MOVF	TMR1HMEM,W	;

	GOTO	SUPPLY
;**********************************************************************

;**********************************************************************
SUPPLY_ONOFF				;     .
FilterPress_0b
	movlw	.255			;        .
	movwf	COUNT4			;c    .
	clrf	COUNT3			;(4MHz) 7PC x 256 x W = 500mS
FilterPress_1b				;
	movlw	.8			;(4MHz) 5PC x 256 x W = 10mS
	movwf	COUNT2			;
	clrf	COUNT1			;
FilterPress_2b				;
	decfsz	COUNT3,F		;
	GOTO	FilterPress_3b		;
	decfsz	COUNT4,F		;
	goto	FilterPress_3b		;
	RETURN				;
FilterPress_3b				;
	btfss	B_LockMode		;1- 
	GOTO	FilterPress_1b		;

	decfsz	COUNT1,F		;
	GOTO	FilterPress_2b		;--^
	decfsz	COUNT2,F		;
	GOTO	FilterPress_2b		;

	movf	CCPR1L,W		;00h -> STATUS,Z=1
	btfsc	STATUS,Z		;
	GOTO	SUPPLY_ON
	GOTO	SUPPLY_OFF
;

SUPPLY_OFF
	bsf	DISCHARGE		;
	bsf	SupplyOFF
	clrf	CCPR1L			; =0x00		 
	bsf	KEY			;
	GOTO	SUPPLY_ONOFF_END	;-->
;

SUPPLY_ON
	bcf	DISCHARGE		;
	bcf	SupplyOFF
	MOVLW	VoltageLevel		;    . EEPROM address
	MOVWF	REEADR			;
	CALL	READE			;
	MOVF	REEDATA,W		;
	MOVWF	CCPR1L			;
	bcf	KEY			;
	GOTO	SUPPLY_ONOFF_END	;-->
;

SUPPLY_ONOFF_END
FilterDown_0b				;     .
	movlw	.10			;   .
	movwf	COUNT4			;(4MHz) 4PC x 256 x W = 10mS
	clrf	COUNT3			;
FilterDown_1b				;
	btfsc	B_LockMode		;
	GOTO	FilterDown_0b		;
	decfsz	COUNT3,F		;
	GOTO	FilterDown_1b		;--^
	decfsz	COUNT4,F		;
	GOTO	FilterDown_1b		;

	RETURN
;**********************************************************************

;**********************************************************************
SetVoltage
	clrf	COUNT_HISPEED

FilterPress_0a
	movlw	.244			;       .
	movwf	COUNT4			;c    .
	clrf	COUNT3			;(4MHz) 8PC x 256 x W = 500mS
FilterPress_1a				;
	movlw	.7			;(4MHz) 6PC x 256 x W = 10mS
	movwf	COUNT2			;
	clrf	COUNT1			;
FilterPress_2a				;
	decfsz	COUNT3,F		;
	goto	FilterPress_3a		;
	decfsz	COUNT4,F		;
	goto	FilterPress_3a		;
	GOTO	SetVoltageEnd		;
FilterPress_3a				;
	btfsc	B_UP			;
	GOTO	FilterPress_4a		;
	btfsc	B_DN			;
	GOTO	FilterPress_4a		;--^
	GOTO	FilterPress_1a		;
FilterPress_4a
	decfsz	COUNT1,F		;
	GOTO	FilterPress_2a		;--^
	decfsz	COUNT2,F		;
	GOTO	FilterPress_2a		;

	btfsc	B_UP			;
	GOTO	ChangeVoltageUp		;
	btfsc	B_DN			;
	GOTO	ChangeVoltageDown	;

ChangeVoltageUp				;   +1
	movlw	MaxVoltage		;
	subwf	CCPR1L,W		;
	btfss	STATUS,C		;CCPR1L >= MaxVoltage	C=1    -->
	incf	CCPR1L,F		;CCPR1L < MaxVoltage	C=0
	GOTO	ChangeVoltage		;-->
;

ChangeVoltageDown			;   -1
	movlw	MinVoltage		;
	subwf	CCPR1L,W		;
	btfsc	STATUS,Z		;CCPR1L = MinVoltage	C=1	Z=1
	GOTO	ChangeVoltage		;Z=1 -->
	btfsc	STATUS,C		;CCPR1L < MinVoltage	C=0
	decf	CCPR1L,F		;CCPR1L > MinVoltage	C=1
	GOTO	ChangeVoltage		;-->
;

ChangeVoltage				;          .

	movlw	.8			;%      ( *  )    .
	subwf	COUNT_HISPEED,W		;%
	movlw	.22			;% 50mS    :
	btfsc	STATUS,C		;% COUNT_HISPEED <  W	C=0
	GOTO	ChangeVoltage0		;% COUNT_HISPEED >= W	C=1
	incf	COUNT_HISPEED,F		;%
	movlw	.130			;% 300mS    :

ChangeVoltage0				;       
	movwf	COUNT2			;    .
	clrf	COUNT1			;(4MHz) 9PC x 256 x W =
ChangeVoltage1				;
	btfsc	B_UP			;
	GOTO	ChangeVoltage1a		;
	btfsc	B_DN			;
	GOTO	ChangeVoltage1a		;
	GOTO	FilterDown_0a		;-->        .
ChangeVoltage1a				;
	btfsc	B_DN			;(       )
	GOTO	ChangeVoltage1b		;
	btfsc	B_UP			;
	GOTO	ChangeVoltage1b		;
ChangeVoltage1b				;
	decfsz	COUNT1,F		;
	GOTO	ChangeVoltage1		;--^
	decfsz	COUNT2,F		;
	GOTO	ChangeVoltage1		;--^

	GOTO	SetVoltageEnd		;-->       .
;

FilterDown_0a				;     .
	movlw	.10			;   .
	movwf	COUNT4			;(4MHz) 4PC x 256 x W = 10mS
	clrf	COUNT3			;
FilterDown_1a				;
	BTFSC	B_UP			;
	GOTO	FilterDown_0a		;
	BTFSC	B_DN			;
	GOTO	FilterDown_0a		;
	decfsz	COUNT3,F		;
	GOTO	FilterDown_1a		;--^
	decfsz	COUNT4,F		;
	GOTO	FilterDown_1a		;

	clrf	COUNT_HISPEED		;%

SetVoltageEnd				;<--
	bsf	ARROW			;
	CALL	SHOW_VOLTAGE		;     (DIGIT10 - DIGIT6).
	CALL	SHOW_CURRENT		;     .
	CALL	LOAD_LCD		;

	movlw	.3			;    ...mS     a.
	movwf	COUNT3			;(4MHz) 7PC x 256 x 256 x W = 2000mS
	clrf	COUNT2			;
	clrf	COUNT1			;
SetVoltageEnd1				;
	btfsc	B_UP			;
	GOTO	FilterPress_0a		;-->.
	btfsc	B_DN			;
	GOTO	FilterPress_0a		;-->.
	decfsz	COUNT1,F		;
	GOTO	SetVoltageEnd1		;--^
	decfsz	COUNT2,F		;
	GOTO	SetVoltageEnd1		;--^
	decfsz	COUNT3,F		;
	GOTO	SetVoltageEnd1		;--^

	movlw	VoltageLevel		;EEPROM address
	movwf	REEADR			;
	movf	CCPR1L,W		;
	movwf	REEDATA			;  EEPROM    .
	CALL	WRITE			;In:F(REEADR,REEDATA)   EEPROM.
	RETURN				;-->  .
;**********************************************************************

;**********************************************************************
LimitCurrentStart
	movlw	CurrentLimit	;EEPROM address
	movwf	REEADR		;
	CALL	READE		;In:F(REEADR)	Out:F(REEDATA),W

LimitCurrentEnd			;          .
	movf	REEDATA,W	;  EEPROM    .
	CALL	SET_CVREF	;  .

	clrf	HEX4		
	clrf	HEX3
	movf	CURRENT_COR2H,W	;0,682A=0,208V
	movwf	HEX2
	movf	CURRENT_COR2L,W
	movwf	HEX1
	movf	REEDATA,W	;W * 208mA
	CALL	MUTIPLIC	;In: F(HEX4,HEX3,HEX2,HEX1) * W
				;Out:F(HEX4,HEX3,HEX2,HEX1)

	BCF	FSRBANK		;0- Bank1,2	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
				;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
	MOVLW	A'L'		;
	MOVWF	TYPE10
	MOVLW	A'I'		;
	MOVWF	TYPE9
	MOVLW	A'M'		;
	MOVWF	TYPE8
	MOVLW	A'I'		;
	MOVWF	TYPE7
	MOVLW	A'T'		;
	MOVWF	TYPE6
	MOVLW	A' '		;
	MOVWF	TYPE5
	MOVLW	A'C'		;
	MOVWF	TYPE4
	MOVLW	A'U'		;
	MOVWF	TYPE3
	MOVLW	A'R'		;
	MOVWF	TYPE2
	MOVLW	A'R'		;
	MOVWF	TYPE1

	MOVLW	A' '
	MOVWF	DIGIT5

	movf	DEC4,W
	movwf	DIGIT4
	movf	DEC3,W
	movwf	DIGIT3
	movf	DEC2,W
	movwf	DIGIT2
	;movf	DEC1,W
	movlw	A'0'
	movwf	DIGIT1

	CALL	SHOW_VOLTAGE		;     (DIGIT10 - DIGIT6).

	bsf	ARROW			;

	CALL	LOAD_LCD		;In:F(TYPE10-TYPE1), F(DIGIT10-DIGIT1)

	movlw	.8			;       
	movwf	COUNT_N			;      400mS.
LimitCurrentEnd1			;
	movlw	.195			;
	MOVWF	TMR0MEM			;
	COMF	TMR0MEM,W		;
	MOVWF	TMR0			;4MHz => 256uS x .195 = 50mS
	bcf	INTCON,TMR0IF		;Overflow TMR0
LimitCurrentEnd1a			;
	btfsc	B_UP			;
	GOTO	LimitCurrentEnd1b	;
	btfsc	B_DN			;
	GOTO	LimitCurrentEnd1b	;
	GOTO	LimitCurrentEnd2a	;-->       .
LimitCurrentEnd1b			;
	btfss	INTCON,TMR0IF		;
	goto	LimitCurrentEnd1a	;-^
	decfsz	COUNT_N,F		;
	GOTO	LimitCurrentEnd1	;--^
	GOTO	LimitCurrentEnd2c	;-->     .


LimitCurrentEnd2a			;     .
	movlw	.195			;50mS
	MOVWF	TMR0MEM			;
	COMF	TMR0MEM,W		;
	MOVWF	TMR0			;4MHz => 256uS x .195 = 50mS
	bcf	INTCON,TMR0IF		;
LimitCurrentEnd2b			;
	BTFSC	B_UP			;
	GOTO	LimitCurrentEnd2a	;1--^
	BTFSC	B_DN			;1--^
	GOTO	LimitCurrentEnd2a	;
	btfss	INTCON,TMR0IF		;Overflow TMR0
	GOTO	LimitCurrentEnd2b	;-^
LimitCurrentEnd2c			;<--


	MOVLW	.30			;    1500mS     a.
	movwf	COUNT_N			;
LimitCurrentEnd3			;
	movlw	.195			;
	MOVWF	TMR0MEM			;
	COMF	TMR0MEM,W		;
	MOVWF	TMR0			;4MHz => 256uS x .195 = 50mS
	bcf	INTCON,TMR0IF		;
LimitCurrentEnd3a			;
	BTFSC	B_UP			;
	GOTO	LimitCurrentUp		;-->.
	BTFSC	B_DN			;
	GOTO	LimitCurrentDown	;-->.

	btfss	INTCON,TMR0IF		;Overflow TMR0
	GOTO	LimitCurrentEnd3a	;-^
	DECFSZ	COUNT_N,F		;
	GOTO	LimitCurrentEnd3	;--^

	CALL	WRITE			;In:F(REEADR,REEDATA)   EEPROM.
	RETURN
;

LimitCurrentUp				;<--
	movlw	.15			;
	subwf	REEDATA,W		;
	btfss	STATUS,C		;REEDATA >= .15	C=1    -->
	incf	REEDATA,F		;REEDATA <  .15	C=0
	GOTO	LimitCurrentEnd		;

LimitCurrentDown			;<--
	movlw	.1			;REEDATA > .1	C=1
	subwf	REEDATA,W		;
	btfsc	STATUS,Z		;REEDATA = .1	C=1	Z=1
	GOTO	LimitCurrentEnd		;Z=1 -->
	btfsc	STATUS,C		;REEDATA < .1	C=0
	decf	REEDATA,F		;C=1
	GOTO	LimitCurrentEnd		;-->
;**********************************************************************

;**********************************************************************
SHOW_CURRENT			;     .
	CALL	READC_RA0	;Out:F(ADRESH,ADRESL)

	clrf	HEX4		;
	clrf	HEX3		;
	movf	ADRESH,W	;0 0 0 0 0 0 9 8 x x x x x x x x
	movwf	HEX2		;
	bsf	STATUS,RP0	;Bank 1
	movf	ADRESL,W	;x x x x x x x x 7 6 5 4 3 2 1 0
	bcf	STATUS,RP0	;Bank 0
	movwf	HEX1		;
	movf	CURRENT_COR1,W	;    
	CALL	MUTIPLIC	;In: F(HEX4,HEX3,HEX2,HEX1) * W
				;Out:F(HEX4,HEX3,HEX2,HEX1)

	BCF	FSRBANK		;0- Bank1,2	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
				;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
	movf	DEC5,W
	movwf	DIGIT4
	movf	DEC4,W
	movwf	DIGIT3
	movf	DEC3,W
	movwf	DIGIT2
	movf	DEC2,W
	movwf	DIGIT1

	RETURN
;**********************************************************************

;**********************************************************************
SHOW_CURRENT_FILTER		;       16 .
				; 16   10bit .
	CALL	READC_RA0	;Out:F(ADRESH,ADRESL)

	bsf	STATUS,RP0	;Bank 1
	movf	ADRESL,W	;x x x x x x x x 7 6 5 4 3 2 1 0
	bcf	STATUS,RP0	;Bank 0
	ADDWF	CURRENT_L,F	;

	movf	ADRESH,W	;0 0 0 0 0 0 9 8 x x x x x x x x
	BTFSC	STATUS,C	;
	addlw	.1		;W+1
	addwf	CURRENT_H,F	;

	decfsz	COUNT_SCR,F	;
	RETURN			;-->

	bcf	STATUS,C	;
	rrf	CURRENT_H,F	;/2
	rrf	CURRENT_L,F	;
	bcf	STATUS,C	;
	rrf	CURRENT_H,F	;/4
	rrf	CURRENT_L,F	;
	bcf	STATUS,C	;
	rrf	CURRENT_H,F	;/8
	rrf	CURRENT_L,F	;
	bcf	STATUS,C	;
	rrf	CURRENT_H,F	;/16
	rrf	CURRENT_L,F	;

	clrf	HEX4		;
	clrf	HEX3		;
	movf	CURRENT_H,W	;
	movwf	HEX2		;
	movf	CURRENT_L,W	;
	movwf	HEX1		;
	movf	CURRENT_COR1,W	;    
	CALL	MUTIPLIC	;In: F(HEX4,HEX3,HEX2,HEX1) * W
				;Out:F(HEX4,HEX3,HEX2,HEX1)

	BCF	FSRBANK		;0- Bank1,2	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
				;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
	movf	DEC5,W
	movwf	DIGIT4
	movf	DEC4,W
	movwf	DIGIT3
	movf	DEC3,W
	movwf	DIGIT2
	movf	DEC2,W
	movwf	DIGIT1

	movlw	.16		;
	movwf	COUNT_SCR	;
	clrf	CURRENT_L	;
	clrf	CURRENT_H	;

	RETURN
;**********************************************************************

;**********************************************************************
SHOW_VOLTAGE			;      (DIGIT10 - DIGIT6).
	CALL	READC_RA1	;Out:F(ADRESH,ADRESL)

	clrf	HEX4		;
	clrf	HEX3		;
	movf	ADRESH,W	;0 0 0 0 0 0 9 8 x x x x x x x x
	movwf	HEX2		;
	bsf	STATUS,RP0	;Bank 1
	movf	ADRESL,W	;x x x x x x x x 7 6 5 4 3 2 1 0
	bcf	STATUS,RP0	;Bank 0
	movwf	HEX1		;
	movlw	.25		;step 25mV
	CALL	MUTIPLIC	;In: F(HEX4,HEX3,HEX2,HEX1) * W
				;Out:F(HEX4,HEX3,HEX2,HEX1)
	BCF	FSRBANK		;0- Bank1,2	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
				;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
	movf	DEC5,W
	sublw	A'0'
	movlw	A' '
	btfss	STATUS,Z
	movf	DEC5,W
	movwf	DIGIT10

	movf	DEC4,W
	movwf	DIGIT9

	movf	DEC3,W
	movwf	DIGIT8

	movf	DEC2,W
	movwf	DIGIT7

	movf	DEC1,W
	movwf	DIGIT6

	RETURN
;**********************************************************************
;**********    *************

;**********************************************************************
WRITE				;In:F(REEADR,REEDATA)
	BSF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank2
	MOVF	REEADR,W	;
	MOVWF	EEADR

	MOVF	REEDATA,W
	MOVWF	EEDATA

	BSF	STATUS,RP1	;
	BSF	STATUS,RP0	;Bank3

	BCF	EECON1,EEPGD	;0 - Accesses data memory EEPROM

	BCF	INTCONMEM,GIE	;
	BTFSC	INTCON,GIE	;
	BSF	INTCONMEM,GIE	;
	BCF	INTCON,GIE	;

	BSF	EECON1,WREN	;1 - Allows write cycles
	MOVLW	0x55		;
	MOVWF	EECON2		;
	MOVLW	0xAA		;
	MOVWF	EECON2		;
	BSF	EECON1,WR	;1 - initiates a write cycles
WRITE_CH			;
	BTFSC	EECON1,WR       ;0 - Write cycles to the EEPROM is complete
	GOTO	WRITE_CH	;-^
	
	BTFSC	INTCONMEM,GIE	;
	BSF	INTCON,GIE	;

	BCF	EECON1,WREN	;disable write
	BCF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank0
	RETURN
;

READE				;In:F(REEADR)	Out:F(REEDATA),W
	BSF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank2
	MOVF	REEADR,W	
	MOVWF	EEADR

	BSF	STATUS,RP1	;
	BSF	STATUS,RP0	;Bank3

	BCF	EECON1,EEPGD	;0 - Accesses data memory EEPROM

	BSF	EECON1,RD	;1 - initiates an EEPOM read
READE_CH
	BTFSC	EECON1,RD	;rd done?
	GOTO	READE_CH	;no then loop

	BSF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank2
	MOVF	EEDATA,W
	MOVWF	REEDATA

	BCF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank0

	RETURN			;
;

READC_RA0			;Analog-to-Digital Converter	Out: F(ADRESH)
	BCF	ADCON0,CHS2	;Select A/D Input Chennel: RA0
	BCF	ADCON0,CHS1	;
	BCF	ADCON0,CHS0	;
	GOTO	READC		;

READC_RA1			;Out: F(ADRESH)
	BCF	ADCON0,CHS2	;Select A/D Input Chennel: RA1
	BCF	ADCON0,CHS1	;
	BSF	ADCON0,CHS0	;
	GOTO	READC		;

READC_RA2			;Out: F(ADRESH)
	BCF	ADCON0,CHS2	;Select A/D Input Chennel: RA2
	BSF	ADCON0,CHS1	;
	BCF	ADCON0,CHS0	;
	GOTO	READC		;

READC_RA3			;Out: F(ADRESH)
	BCF	ADCON0,CHS2	;Select A/D Input Chennel: RA3
	BSF	ADCON0,CHS1	;
	BSF	ADCON0,CHS0	;
	GOTO	READC		;

READC_RA4			;Out: F(ADRESH)
	BSF	ADCON0,CHS2	;Select A/D Input Chennel: RA4
	BCF	ADCON0,CHS1	;
	BCF	ADCON0,CHS0	;
	GOTO	READC		;

READC
	BSF	ADCON0,ADON	;1 = A/D converter module is operating
	MOVLW	.10		;.10 Fosc=4MHz	.20 Fosc=8MHz
	MOVWF	ACQT		;Acquisition Time 20uS.
	DECFSZ	ACQT,F		;-
	GOTO	$-1		;-^

	BSF	ADCON0,GO	;Start Convertion
READC_CH			;
	BTFSC	ADCON0,GO	;
	GOTO	READC_CH	;-^
	BCF	ADCON0,ADON	;0 = A/D converter is shut_off
	RETURN			;
;

SET_ADC
	BSF	STATUS,RP0	;Bank1
	MOVWF	ANSEL		;Analog Select Register
	BSF	ADCON1,VCFG1	;A/D Voltage Reference Configuration
	BCF	ADCON1,VCFG0	;
	bsf	ADCON1,ADFM	;x x / X X X X X X X X	!!!
	BSF	ADCON1,ADCS2	;Select A/D Conversion Clock 16xTosc = 4uS at 4MHz!!!
	BCF	STATUS,RP0	;Bank0
	BCF	ADCON0,ADCS1	;Select A/D Conversion Clock
	BSF	ADCON0,ADCS0	;-//-
	RETURN
;

SET_OSC				;Oscillator configuration.
	BSF	STATUS,RP0	;Bank1
	MOVWF	OSCCON		;
	BCF	OSCCON,SCS1	;0 - Oscillator Mode Defined By h'2007'
	BCF	OSCCON,SCS0	;0
	MOVLW	OSCTUNE_MNL	;Central frequency
	MOVWF	OSCTUNE		;
	BCF	STATUS,RP0	;Bank0
	RETURN			;
;

SET_TMR0
	BSF	STATUS,RP0	;Bank1
	BCF	OPTION_REG,T0CS	;0 - Intrnal Clock Source
	BTFSC	OPTION_REG,T0CS	;
	BCF	OPTION_REG,T0SE	;0 - Rising Transition RA4

	BCF	OPTION_REG,PSA	;0 - Prescaler Is Assigned To The TMR0 Module
	BTFSC	OPTION_REG,PSA	;
	GOTO	SET_TMR0_1	;-->

	MOVF	OPTION_REG,W	;
	ANDLW	B'11111000'	;  PS2 PS1 PS0
	;IORLW	B'00000000'	;Fosc/4/2	4MHz =>   2uS
	;IORLW	B'00000001'	;Fosc/4/4
	;IORLW	B'00000010'	;Fosc/4/8
	;IORLW	B'00000011'	;Fosc/4/16
	;IORLW	B'00000100'	;Fosc/4/32
	;IORLW	B'00000101'	;Fosc/4/64
	;IORLW	B'00000110'	;Fosc/4/128
	IORLW	B'00000111'	;Fosc/4/256	4MHz => 256uS
	MOVWF	OPTION_REG	;

SET_TMR0_1
	BCF	STATUS,RP0		;Bank0
	RETURN
;

SET_TMR1			;Timer1 Module:	Max period 8uS * 65536 = 524,288mS
	BCF	T1CON,T1RUN	;1 - System clock is derived from Timer1 oscillator
	BSF	T1CON,T1CKPS1	;Timer prescaler /1 - 0   /2 - 0   /4 - 1   /8 - 1
	BSF	T1CON,T1CKPS0	;Timer prescaler      0        1        0        1
	BCF	T1CON,T1OSCEN	;Oscillator is shut off.
	BSF	T1CON,NOT_T1SYNC ;1 - Do not synchronize external clock input
	BCF	T1CON,TMR1CS	;Internal Clock Fosc/4	4MHz = 8uS
	BSF	T1CON,TMR1ON	;Timer1 On bit.
	RETURN
;

SET_PWM				;Reset Pulse Width Modulation
	BSF	STATUS,RP0	;Bank1
	BCF	TRISB,3		;RB3 Output!
	MOVLW	0xFF		;
	MOVWF	PR2		;Period register.
	BCF	STATUS,RP0	;Bank0

	CLRF	CCPR1L		;Bit 9 - 2
	BCF	CCP1CON,CCP1X	;Bit 1
	BCF	CCP1CON,CCP1Y	;Bit 0

	BCF	T2CON,T2CKPS1	;Timer prescaler 1 - 0   4 - 0   16 - 1
	BCF	T2CON,T2CKPS0	;Timer prescaler     0       1        X

	BSF	T2CON,TMR2ON	;Timer2 is ON.

	MOVLW	B'00001100'	;PWM mode.
	MOVWF	CCP1CON		;
	RETURN
;

SET_CVREF
	BSF	STATUS,RP0	;Bank1
	MOVWF	CVRCON		;
	BSF	CVRCON,CVRR	;Range
	BSF	CVRCON,CVROE	;Output Enable Bit.
	BSF	CVRCON,CVREN	;Module Enable Bit.
	BCF	STATUS,RP0	;Bank0
	RETURN
;

SET_COMPM
	BSF	STATUS,RP0	;Bank1
	MOVLW	B'00000111'	;I/O Operating Modes.
	MOVWF	CMCON		;
	BCF	CMCON,CIS	;Input Switch Bit.
				;
	BCF	STATUS,RP0	;Bank0
	RETURN			;
;

SET_UART
	BANKSEL	SPBRG
	MOVWF	SPBRG

	BANKSEL	TRISB
	BCF	TRISB,5		;Serial Output
	BSF	TRISB,2		;Serial Input

	BANKSEL	RCSTA		;Receive Status & Control Register
	BSF	RCSTA,SPEN	;1-> Serial Port Enabbled
	BCF	RCSTA,RX9	;0-> 8bit RX	1-> 9bit RX
	;BCF	RCSTA,SREN	;
	BCF	RCSTA,CREN	;		1-> Enables Continuous Receive !!!
	BCF	RCSTA,ADDEN	;Address Detect Enable bit
	;BCF	RCSTA,FERR	;0-> No Framing Error
	;BCF	RCSTA,OERR	;0-> No Overrun Error
	;BCF	RCSTA,RX9D	;9th bit of Receive Data

	BANKSEL	TXSTA		;Trasnit Status & Control Register
	;BCF	TXSTA,CSRC	;
	BCF	TXSTA,TX9	;0-> 8bit TX	1-> 9bit TX
	BSF	TXSTA,TXEN	;0-> Disable	1-> Enable TX
	BCF	TXSTA,SYNC	;0-> Asynchron	1-> Synchronous
	BSF	TXSTA,BRGH	;0-> Low-speed	1-> High-speed
	;BCF	TXSTA,TX9D	;9bit Parity Bit

	BANKSEL	0
	RETURN
;

SET_WDT
	BSF	STATUS,RP0	;Select Bank1.
	MOVLW	B'00010110'	;1:65536
	MOVWF	WDTCON		;
	BCF	WDTCON,SWDTEN	;1 - WDT Is Turned ON (If Configuration Bit=0 disable)
	BCF	STATUS,RP0	;Select Bank0.
	RETURN
;**********************************************************************

;*******   **********************
START
	BCF	STATUS,RP1	;Bank0
	BCF	STATUS,RP0	;

	BCF	FSRBANK		;0- Bank1,2	1- Bank2,3	    FSR.
	BCF	WPAGE		;0- Work. Page0		1- Work. Page1

	CLRF	PORTA
	CLRF	PORTB

	CLRF	INTCON		;  .
	BSF	STATUS,RP0	;Select Bank1.
	CLRF	PIE1
	CLRF	PIE2
	BCF	STATUS,RP0	;Select Bank0.

	;MOVLW	B'01110000'	;Internal oscillator	8MHz
	MOVLW	B'01100000'	;Internal oscillator	4MHz
	;MOVLW	B'01010000'	;Internal oscillator	2MHz
	;MOVLW	B'01000000'	;Internal oscillator	1MHz
	;MOVLW	B'00110000'	;Internal oscillator	500KHz
	;MOVLW	B'00100000'	;Internal oscillator	250MHz
	;MOVLW	B'00010000'	;Internal oscillator	125MHz
	;MOVLW	B'00000000'	;Internal oscillator	31,25KHz
	CALL	SET_OSC		;Oscillator configuration!

	BSF	STATUS,RP0		;Select Bank1.
	BSF	OPTION_REG,NOT_RBPU	;1 - Pull-ups Disabled
	BSF	OPTION_REG,INTEDG	;1 - Rising RB0 Interrupt
	BCF	STATUS,RP0		;Select Bank0.

	MOVLW	B'00001011'	;0 - Digital I/O	1 - Analog Input RA0,RA1,Vref+(RA3)
	CALL	SET_ADC		;ADC configuration!

	CALL	SET_TMR0	;

	CALL	SET_TMR1	;

	MOVLW	B'00000010'	;Bit(3-0)level
	CALL	SET_CVREF	;Enable Comparator Voltage Reference Module & Reset - RA2

	CALL	SET_COMPM	;

	CALL	SET_WDT

	BSF	STATUS,RP0	;Select Bank1.
	MOVLW	B'11101111'	;
	MOVWF	TRISA		;PortA
	MOVLW	B'01111111'	;
	MOVWF	TRISB		;PortB
	BCF	STATUS,RP0	;Select Bank0.

	CALL	SET_PWM		;Enable PWM & Reset - RB3

	;MOVLW	.25		;19200 bps UART	8MHz
	;MOVLW	.12		;19200 bps	4Mhz
	;CALL	SET_UART

	GOTO	BEGIN		;--^

;********************Multiplic 32bit * 8bit****************************
	#include	<MULTIPLIC32_8.asm>	;
;**********************************************************************

;**************** HEX - >DEC -> ASCII********************
	#include	<HEX4ASCII10_5.asm>	;
;**********************************************************************

;************  PHILIPS PCF8578 I2C-100KHz**************
	ORG	0x0600			;!
PCLATH_PCF8578	EQU	.6		; ORG 0x600 to 0x6FF !!!
	#include	<PCF8578_5.asm>	;	Fosc=4MHz!!
;**********************************************************************

        END